--vray preset manager
--by marc lorenz
--http://plugins.marclorenz.com
--plugins@marclorenz.com
--
--feel free to use parts of this script for your own stuff
--but please don't publish modified versions of the script




-----------------------------------------------
--changing anything below will lead to disaster
--

(

--debug mode, logs parsing errors to the listener
local logerrors=false

local scriptVersion="1.1"

global ml_presetman, ml_linkEngine, ml_draftPreset, ml_draftPresetName, ml_VPNcallbackActive

global ml_maxver=maxversion()

if ml_draftPresetName==undefined then ml_draftPresetName=""
if ml_VPNcallbackActive==undefined then ml_VPNcallbackActive=false

--function for callback
fn ml_linkEngine=
(
--clone settings from production to draft
for i in (getpropnames vray) do
	(
	try execute ("renderers.draft."+(i as string)+"=renderers.production."+(i as string))
	catch ()
	)
--apply draft preset
for i in ml_draftPreset do
	(
	try execute i
	catch ()
	)
)

fn IsUNCpath fPath = ( --function by footools.com
	if	(classOf fPath == string) AND
		(fPath.count >= 2) AND
		(fPath[1] == "\\") AND
		(fPath[2] == "\\") then TRUE else FALSE
)

fn FixFilename fName = ( --function by footools.com
	local strArray = filterString fName "\\"
	local fixedName = if (isUNCpath fName) then "\\\\" else ""
	for i in 1 to (strArray.count-1) do fixedName += (strArray[i] + "\\")
	fixedName += strArray[strArray.count]
	return fixedName
)

--max5 only method
--targetslot: 1:production 2:draft
fn isLoadedVray targetslot assign:false=
	(
	
	try
	(
	if (targetslot==1) then slot=renderers.production
	else slot=renderers.draft
	)
	catch()
	
	--is vray even installed?
	a=(findItem RendererClass.classes vray)
	if (a!=0) then
		(
		--detect if ANY VRay version is active
		if (findString (slot as string) "V_ray"!=undefined) then return true
		else
			(
			if assign then 
				(
				if (queryBox "VRay is not the active renderer.   \nLoad it and proceed?" title:"Warning") then
					(
					--store current
					--dumb maxscript can only assign to currently avtive renderer slots
					b=renderer
					case targetslot of
						(
						1:	(
							renderer=#production
							renderers.production=RendererClass.classes[a]()
							)
						2:	(
							renderer=#draft
							renderers.draft=RendererClass.classes[a]()
							)
						)
					--reassign current
					renderer=b
					return true
					)
				)
			)
		)
	return false
	)
	

fn loadINI name=
	(
	getINISetting "$plugcfg/ml_vpm.ini" "Settings" name
	)
	
fn saveINI name val=
	(
	setINISetting "$plugcfg/ml_vpm.ini" "Settings" name (val as string)
	)

fn loadSettingINI name filename=
	(
	getINISetting filename "General" name
	)
	
fn loadPresetINI name filename=
	(
	getINISetting filename "Settings" name
	)
	
fn savePresetINI name val filename=
	(
	if (classOf val)==String then val="\"\""+val+"\"\""
	setINISetting filename "Settings" name (val as string)
	)


--
--get settings from INI if available
--

presetsPath=loadINI "presetsPath"
if presetsPath=="" then presetsPath="$plugcfg\\VrayPresets"

dialogPosX=(loadINI "dialogPosX") as number
if dialogPosX==0 then dialogPosX=300

dialogPosY=(loadINI "dialogPosY") as number
if dialogPosY==0 then dialogPosY=200

dialogW=(loadINI "dialogW") as number
if dialogW==0 then dialogW=276

dialogH=(loadINI "dialogH") as number
if dialogH==0 then dialogH=300

listShowAuthor=(loadINI "listShowAuthor")
if listShowAuthor=="" then listShowAuthor=false else listShowAuthor=execute listShowAuthor

listShowVersion=(loadINI "listShowVersion")
if listShowVersion=="" then listShowVersion=false else listShowVersion=execute listShowVersion

--

local presetsArray=#()
local presetFiles=FixFilename presetsPath+"\\*.ini"

--detect light/dark ui for icons and hyperlink
local hyperlink_color, ui_color
if (colorMan.getColor #text).x < 0.2 then 
	(
	ui_color=3
	hyperlink_color=(color 8 8 136)
	)
else
	(
	ui_color=1
	hyperlink_color=white
	)


--MENUS

rcMenu cmenu
	(
		menuItem assignProd "Assign to Production"
		--menuItem assignDraft "Assign to Draft"
		--seperator sep1_2
		menuItem editview "Edit"
		separator sep1_3
		--menuItem copy "Make Copy..."
		menuItem delete "Delete"

		on editview picked do ml_presetman.editViewPreset()
		on delete picked do ml_presetman.deletePreset()
		
		on assignProd picked do
			(
			if (isLoadedVray 1 assign:true) then ml_presetman.loadPreset 1
			)
		
		--on assignDraft picked do
		--	(
		--	if (isLoadedVray 2 assign:true) then ml_presetman.loadPreset 2
		--	)
	
	)

rcMenu mainmenu
	(
	subMenu "File"
		(
		menuItem createPreset "Create Preset..."
		seperator sep1_1
		menuItem assignProd "Assign to Production"
		--menuItem assignDraft "Assign to Draft"
	--	seperator sep1_2
		menuItem editview "Edit"
		separator sep1_3
		--menuItem copy "Make Copy..."
		menuItem delete "Delete"
		separator sep1_4
		menuItem closeMenu "Exit"
		)
		
	subMenu "View"
		(
		menuItem refreshList "Refresh List"		
		menuItem openFolder "Open Presets Folder"
		seperator sep3_1
		menuItem prefs "Preferences..."
		)
		
-- 	subMenu "?"
-- 		(
-- 		menuItem web_index "Webpage"
-- 		menuItem web_manual "Online Manual"
-- 		menuItem web_faq "FAQ && Tips"
-- 		separator sep4_1
-- 		menuItem info "About..."
-- 		)
-- 	
	--on linkMenu picked do ml_presetman.triggerLink()
	
	
	on refreshList picked do ml_presetman.parsePresets reset:true
	
	on assignProd picked do
		(
		if (isLoadedVray 1 assign:true) then ml_presetman.loadPreset 1
		)
		
	on assignDraft picked do
		(
		if (isLoadedVray 2 assign:true) then ml_presetman.loadPreset 2
		)
	
	on editview picked do ml_presetman.editViewPreset()
	on delete picked do ml_presetman.deletePreset()
	on createPreset picked do
		(
		rollout ro_createPreset "Create Preset..."
			(
			label lbl0 " "
			--	radiobuttons select_slot "Use Settings of:" labels:#("Production","Draft") align:#left
			radiobuttons select_slot "Use Settings of:" labels:#("Production") align:#left
				label lbl2 " "
			label lbl4 "Preset Name (required):" align:#left
			edittext edit_presetname align:#left height:19
			label lbl5 "Description:" align:#left
			edittext edit_descr align:#left height:19
			label lbl3 "Author:" align:#left
			edittext edit_author align:#left height:19
			label lbl6 ""		
			button saveAs "Save As..." width:75 align:#center across:2
			button closeDialog "Cancel" width:75 align:#center

			on closeDialog pressed do destroyDialog ro_createPreset

			on saveAs pressed do
				(
				local targetdir=FixFilename presetsPath+"\\" + edit_presetname.text
				if (edit_presetname.text!="") then filename=getSaveFileName caption:"Save As..." filename:targetdir types:"Vray Preset(*.ini)|*.ini"
				destroyDialog ro_createPreset
				if (filename!=undefined) then
					(
					if (isLoadedVray select_slot.state) then
						(
						if ((getfiles filename).count != 0) then deleteFile filename
						stream=createFile filename
						format ";Vray Preset File\n" to:stream
						format ";created with Vray Preset Manager\n" to:stream
						format ";http://plugins.marclorenz.com/vraypm\n;------------------------------------\n" to:stream
						format ";feel free to delete values you don't want to include in the preset.\n\n" to:stream
						format "[General]\n" to:stream
						format "PresetName=%\n" edit_presetname.text to:stream
						format "Description=%\n" edit_descr.text to:stream
						format "Author=%\n" edit_author.text to:stream
						format "RendererVersion=%\n" vray to:stream
						format "PresetManagerVersion=%\n" scriptVersion to:stream
						format "\n[Settings]\n" to:stream
						close stream
						
						--find renderer values and store to ini
						for i in (getpropnames vray) do
							(
							case select_slot.state of
								(
								--max5 only method
								1: savePresetINI (i as string) (getProperty renderers.production i) filename
								2: savePresetINI (i as string) (getProperty renderers.draft i) filename
								)
							)
						ml_presetman.parsePresets reset:true
						)
						else
							(
							messageBox "Unable to create preset because VRay isn't active in the choosen renderer-slot." title:"Error"
							)
					)
				)
			)
		CreateDialog ro_createPreset 225 260 modal:true style:#(#style_sysmenu,#style_toolwindow) pos:((getDialogPos ml_presetman)+[25,40])
		)
	
	on openFolder picked do shellLaunch presetsPath ""

	on closeMenu picked do destroyDialog ml_presetMan
	
	on selectColumns picked do
		(
		rollout ro_selectColumns "Select Columns in List..." 
			(
			label lbl0 ""
			label lbl1 "Available Columns:" align:#left
			edittext available_cols text:"Version Test Author Description" align:#left height:19
			label lbl2 " "
			label lbl3 "Current Columns: (Seperate with space)" align:#left
			edittext current_cols align:#left height:19
			label lbl6 ""		
			button saveAs "OK" width:75 align:#center across:2
			button close "Cancel" width:75 align:#center
			on close pressed do destroyDialog ro_selectColumns
			)
		CreateDialog ro_selectColumns 225 180 modal:true style:#(#style_sysmenu,#style_toolwindow) pos:((getDialogPos ml_presetman)+[25,60])
		)
	
	--on web_index picked do shellLaunch "http://plugins.marclorenz.com/vraypm/index.htm" ""
	--on web_manual picked do shellLaunch "http://plugins.marclorenz.com/vraypm/manual.htm" ""
	--on web_faq picked do shellLaunch "http://plugins.marclorenz.com/vraypm/faq.htm" ""
	
	on info picked do
		(
		rollout ro_about "About"
			(
			label lbl0 " "
			label lbl1 "Vray Preset Manager" align:#left
			label lbl2 align:#left
			label lbl3 " "
			label about08 "Copyright (c) 2003 by Marc Lorenz" align:#left
			hyperLink link1 "plugins@marclorenz.com" address:"mailto:plugins@marclorenz.com"
			label about12 " "
			button close "OK" width:75 align:#center
			on close pressed do destroyDialog ro_about
			on ro_about open do
				(
				lbl2.text="Version: "+(scriptVersion as string)
				link1.color=hyperlink_color
				link1.hovercolor=hyperlink_color
				link1.visitedcolor=hyperlink_color
				)
			)
		
		CreateDialog ro_about 220 170 modal:true style:#(#style_sysmenu,#style_toolwindow) pos:((getDialogPos ml_presetman)+[25,80])

		)
		
	on prefs picked do
		(
		rollout ro_prefs "Preferences"
			(
			label lbl0 " \n "
			group "Additional List Columns"
				(
				checkBox chkAuthor "Show Author" checked:listShowAuthor
				checkBox chkVersion "Show Renderer Version" checked:listShowVersion
				)

			label lbl2 "Changes take effect after restart." align:#left
			label lbl3 ""
			button close "OK" width:75 align:#center
			on close pressed do destroyDialog ro_prefs
			
			on chkAuthor changed a do
				(
				listShowAuthor=a
				)
			on chkVersion changed a do
				(
				listShowVersion=a
				)
			)
		
		CreateDialog ro_prefs 220 160 modal:true style:#(#style_sysmenu,#style_toolwindow) pos:((getDialogPos ml_presetman)+[25,80])

		)

	
		on assignProd picked do
		(
		if (isLoadedVray 1 assign:true) then ml_presetman.loadPreset 1
		)

	)

--MENUS END

try destroyDialog ml_presetman
catch ()

rollout ml_presetman "VRay Preset Manager"
	(
	ActiveXControl lvElements "MSComctlLib.ListViewCtrl" pos:[13,26]
	label lbl1 "Installed Presets:" pos:[13,8] width:119 height:13
	button assignProdButton width:96 height:32 align:#left images:#("$scripts/ml_plugins/ml_vpm_ui_i.bmp","$scripts/ml_plugins/ml_vpm_ui_d.bmp",8,ui_color+1,ui_color+5,ui_color+1,ui_color+1) tooltip:"Assign Selected Preset to Production Renderer"
	--***---------------------------------DONT NEED-----------------------------------------------
	--button assignDraftButton width:96 height:32 align:#left offset:[154,0] images:#("$scripts/ml_plugins/ml_vpm_ui_i.bmp","",8,ui_color,ui_color+4,ui_color,ui_color) tooltip:"Assign Selected Preset to Draft Renderer"
	--checkbutton linkButton width:32 height:32 align:#left offset:[109,0] images:#("$scripts/ml_plugins/ml_vpm_ui2_i.bmp","$scripts/ml_plugins/ml_vpm_ui2_a.bmp",3,ui_color,ui_color,ui_color,ui_color) tooltip:"Link Draft Settings to Production" highlightColor:(color 90 129 201)
	--label lblProd "Production: No Preset loaded." align:#left
	--label lblDraft "Draft: No Preset loaded." align:#left
	
	
	--activeX listview nonsense
	function initLv lv  =
		(
		lv.backColor = (color 245 245 245)
		lv.foreColor = (color 150 150 150)
		lv.font.name="Arial"
		lv.font.size=9
		lv.gridLines = false
		lv.checkBoxes = false
		lv.borderStyle = #ccNone
		lv.appearance = #cc3d
		lv.view = #lvwReport
		lv.fullRowSelect = true
		lv.multiSelect = false
		lv.labelEdit = #lvwManual
		lv.hideSelection = false
		lv.sorted = true
		lv.allowColumnReorder = true
	 	lv.hideColumnHeaders = false
		
		t1 = lv.ColumnHeaders.add()
		t1.text = "Preset Name"
		t2 = lv.ColumnHeaders.add()
		t2.text = "Description"
		
		if listShowAuthor then
			(
			t3 = lv.ColumnHeaders.add()
			t3.text = "Author"
			)
		if listShowVersion then
			(			
			t4 = lv.ColumnHeaders.add()
			t4.text = "Version"
			)
	
		local LVM_FIRST = 0x1000, LVM_SETCOLUMNWIDTH = (LVM_FIRST + 30)
		windows.sendMessage lv.hwnd LVM_SETCOLUMNWIDTH  0 120
	    windows.sendMessage lv.hwnd LVM_SETCOLUMNWIDTH  1 120
	    windows.sendMessage lv.hwnd LVM_SETCOLUMNWIDTH  2 80
	    windows.sendMessage lv.hwnd LVM_SETCOLUMNWIDTH  3 80
		
		)
	
	function getLvSelection lv =
	(
		for i in 1 to lv.listItems.count do
		(
			li = lv.listItems[i]
			if li.selected then
				return i
		)
		return 0
	)
	
	function getLvItemName lv nItem =
	(
		if nItem > 0 and nItem <= lv.listItems.count then
		(
			return (lv.listItems[ nItem ]).text
		) else return ""
	)
	
	
	function setLvItemName lv nItem newName =
	(
		if nItem > 0 and nItem <= lv.listItems.count then
		(
			(lv.listItems[ nItem ]).text = newName as string
		) 
	)
	
	function addLvItem _lv _text1 _text2 _text3 _text4=
	(
		li = _lv.ListItems.add()

		li.text = _text1
		li2 = li.ListSubItems.add()
		li2.text = _text2 

		if listShowAuthor then
			(
			li3 = li.ListSubItems.add()
			li3.text = _text3 
			li4 = li.ListSubItems.add()
			li4.text = _text4
			)
		else
			(			
			li3 = li.ListSubItems.add()
			li3.text = _text4
			)
	
	)
	
	function deleteLvItem lv item =
	(
		if( item != undefined ) and (item > 0) then
			lv.listItems.remove( item )
	)
	

	fn highlightLinkPreset=
		(
		for i=1 to presetsArray.count do
			(
			if ((ml_draftPresetName==presetsArray[i][1]) AND (ml_presetman.linkButton.checked==true)) then 
				(
				ml_presetman.lvElements.ListItems[i].ForeColor=(color 200 110 60)
				ml_presetman.lvElements.ListItems[i].Bold=true

				callbacks.addScript #renderParamsChanged "ml_LinkEngine()" id:#ml_VRayPresetManagerLink

				)
			else
				(
				ml_presetman.lvElements.ListItems[i].ForeColor=(color 0 0 0)
				ml_presetman.lvElements.ListItems[i].Bold=false
				
				)
			)
		)
	
	fn parsePresets reset:false=
		(
		if reset then
			(
			lvElements.ListItems.Clear()
			)
		presetsArray=#()
		local PresetName
		for i in (getFiles presetFiles) do
			(
			--check for duplicate preset names, would corrupt listview hittest
			PresetName=(loadSettingINI "PresetName" i)
			for i2 in presetsArray do
				(
				if i2[1]==PresetName do continue --cancel current loop, should output warning?
				)
			append presetsArray #((loadSettingINI "PresetName" i),(loadSettingINI "Description" i),(loadSettingINI "Author" i),(loadSettingINI "RendererVersion" i),i)
			)
		
		for i in presetsArray do
			(
			addLvItem lvElements i[1] i[2] i[3] i[4]
			)
		for i=1 to presetsArray.count do
			(
			ml_presetman.lvElements.ListItems[i].ForeColor=(color 0 0 0)
			ml_presetman.lvElements.ListItems[i].ToolTipText=presetsArray[i][2]
			)
		ml_presetman.highlightLinkPreset()
		)
	
	fn getSelectionFilename=
		(
		--currently selected, must search in original array because of possible listview reorder
		--fatal with duplicate names
		a=ml_presetman.lvElements.selecteditem.text
		for i in presetsArray do
			(
			if (i[1]==a) then return i[5]
			)
		)
	
	fn getSelectionDescr=
		(
		--currently selected, must search in original array because of possible listview reorder
		--fatal with duplicate names
		a=ml_presetman.lvElements.selecteditem.text
		for i in presetsArray do
			(
			if (i[1]==a) then return i[2]
			)
		)
	
	fn editViewPreset=
		(
		filename=getSelectionFilename()
		if ((getfiles filename).count != 0) then shellLaunch filename ""
		)
	
	fn deletePreset=
		(
		filename=getSelectionFilename()
		if (queryBox "Really delete the selected Preset?" title:"Delete Preset") then 
			(
			deleteFile filename
			deleteLvItem ml_presetman.lvElements (getLvSelection ml_presetman.lvElements)
			)
		)
		
	fn loadPreset targetslot=
		(
		filename=getSelectionFilename()
		if ((getfiles filename).count != 0) then
			(
			local slot
			case targetslot of
				(
				1:	slot="renderers.production."
				2:	(
					slot="renderers.draft."
					ml_draftPreset=#()
					ml_draftPresetName=ml_presetman.lvElements.selecteditem.Text
					)
				)
				
			for i in (getpropnames vray) do
				(
				a=loadPresetINI i filename
				if (a!="") then 
					(
					c=(slot+i+"="+a)
					if (targetslot==2) then
						(
						append ml_draftPreset c
						)
					try execute c
					catch
						(
						if logerrors then print c
						)
					)
				)
			highlightLinkPreset()
			)
		--case targetslot of
		--	(
		--	1: 	--ml_presetman.lblProd.text="Production: "+ml_presetman.lvElements.selecteditem.text
		--	2:	(--
				--ml_presetman.lblDraft.text="Draft: "+ml_presetman.lvElements.selecteditem.text
				--ml_draftPresetName=ml_presetman.lvElements.selecteditem.text
			--	)--
		--	)
		--callback only works when render settings window is open, so clone when loading presets too
		if ml_VPNcallbackActive then ml_linkEngine()
		)
	
	
	fn triggerLink state=
		(
		--ml_presetman.linkMenu.checked=true
		case state of 
			(
			
			true:
				(
				ml_VPNcallbackActive=true
				ml_presetman.linkButton.checked=true
				ml_presetman.highlightLinkPreset()
				
				if ml_draftPresetName!="" then ml_linkEngine()
				)
			false:
				(
				ml_VPNcallbackActive=false
				ml_presetman.linkButton.checked=false
				ml_presetman.highlightLinkPreset()
				callbacks.removeScripts #renderParamsChanged id:#ml_VRayPresetManagerLink
				)
			)

		)
	
	----------------
	--EVENT HANDLERS
	----------------
	
	fn resized=
		(
			--***----------------------DONT NEED-----------------------------	
		lvElements.size = [ml_presetman.width,ml_presetman.height] - [26, 130]
		assignProdButton.pos.y = ml_presetman.height - 90
		--***----------------------DONT NEED-----------------------------
		--linkButton.pos.y = ml_presetman.height - 90
		--assignDraftButton.pos.y = ml_presetman.height - 90
		--lblProd.pos.y=ml_presetman.height - 45
		--lblDraft.pos.y=ml_presetman.height - 30
	
		)
	
	on ml_presetman open do
		(
		resized()
		initLv lvElements
		
		parsePresets()
		
		if ml_VPNcallbackActive then triggerLink true
		)

	on ml_presetman resized a do
		(
		resized()
		)
	
	on ml_presetman close do
		(
		saveINI "presetsPath" presetsPath
		saveINI "dialogPosX" ((GetDialogPos ml_presetman).x as integer)
		saveINI "dialogPosY" ((GetDialogPos ml_presetman).y as integer)
		saveINI	"dialogW" ml_presetman.width
		saveINI	"dialogH" ml_presetman.height
		
		saveINI "listShowAuthor" listShowAuthor
		saveINI "listShowVersion" listShowVersion
		
		if (ml_VPNcallbackActive==false) then
			(
			ml_draftPreset=undefined
			ml_draftPresetName=undefined
			)
		)
	
	on lvelements ColumnClick a do
		(
		if (lvelements.sortkey==(a.index-1)) then 
			(
			if (lvelements.SortOrder==#lvwAscending) then lvelements.SortOrder=#lvwDescending
			else lvelements.SortOrder=#lvwAscending
			)
		else 
			(
			lvelements.sortkey=(a.index-1)
			lvelements.SortOrder=#lvwAscending
			)
		)
	
	on lvElements MouseUp btn shift x y do
		(
		fn getHitNode = 
			(
			local p = getCursorPos lvElements
			lvElements.hitTest (p.x*15) (p.y*15)			
			)
		enableAccelerators = false			
		local sel = getHitNode()
		if btn == 2 and sel != undefined do
			(
			lvElements.selectedItem = sel
			popupmenu cmenu pop:[x, y] rollout:ml_presetman				
			)
		)
	
	on assignProdButton pressed do
		(
		if (isLoadedVray 1 assign:true) then ml_presetman.loadPreset 1
		)
	--on assignDraftButton pressed do
	--	(
	--	if (isLoadedVray 2 assign:true) then ml_presetman.loadPreset 2
	--	)
	--on linkButton changed state do triggerLink state



)

createDialog ml_presetman menu:mainmenu style:#(#style_sysmenu,#style_toolwindow,#style_resizing) pos:[dialogPosX,dialogPosY] width:dialogW height:dialogH
)
